from BkGlobals import *
import sys
import math
import pygame

#import time

#Pos is center. Returns center
def getNearestValidPos(pos, blockRect, rectNoCollideList):
	moveBlockRect = blockRect.move	

	testRect = blockRect

	bestPos = None
	
	#t = time.time()
	
	if blockRect.collidelist(rectNoCollideList) == -1:
		# Find nearest			
		for iIteration in range(1, GAME_SURFACE_SIZE[1]):		
			testRect = moveBlockRect(0, iIteration)
			if testRect.collidelist(rectNoCollideList) != -1:
				bestPos = (testRect.center[0], testRect.center[1] - 1)
				break
				
		blockRect.center = bestPos
									
	elif blockRect.collidelist(rectNoCollideList) != -1:
		width = blockRect.width
		height = blockRect.height
		
		checkRadiusWidth = 0
		checkRadiusHeight = 0
		bestDistSq = sys.maxint
		bestPos = None
		
		# I'd like to get this to cover the whole screen. STILL not fast enough. Main problem is in checkPosClose
		# currently it covers every possible pixel location from the centrepoint. A bit icky with larger blocks
		
		# This makes sure we have a square of search areas. Not perfect, but better than previous implementation
		while min(checkRadiusWidth * width, checkRadiusHeight * height) < 300:
			if checkRadiusWidth * width <= checkRadiusHeight * height:
				checkRadiusWidth += 1
				# Verticals
				for i in range(-((width / 2) * checkRadiusWidth), ((width / 2) * checkRadiusWidth) + 1, max(1, width * checkRadiusWidth)):
					for j in range(-((height / 2) * checkRadiusHeight), ((height / 2) * checkRadiusHeight) + 1, height / 2):
						bSpace = True
						checkPos = (pos[0] + i, pos[1] + j)
						for rect in rectNoCollideList:
							if rect.collidepoint(checkPos):
								bSpace = False
								break		
								
						if bSpace:	
							bestPos, bestDistSq = checkPosClose(pos, checkPos, blockRect, rectNoCollideList, bestPos, bestDistSq)
				
							
			else:	
				checkRadiusHeight += 1
				
				# Horizontals
				for i in range(-((width / 2) * checkRadiusWidth), ((width / 2) * checkRadiusWidth) + 1, width / 2):
					for j in range(-((height / 2) * checkRadiusHeight), ((height / 2) * checkRadiusHeight) + 1, max(1, height * checkRadiusHeight)):				
						bSpace = True
						checkPos = (pos[0] + i, pos[1] + j)
						for rect in rectNoCollideList:
							if rect.collidepoint(checkPos):
								bSpace = False
								break
								
						if bSpace:	
							bestPos, bestDistSq = checkPosClose(pos, checkPos, blockRect, rectNoCollideList, bestPos, bestDistSq)
							
				
							
			if bestPos:
				blockRect.center = bestPos
				break
		
		if bestPos:
			for iIteration in range(1, GAME_SURFACE_SIZE[1]):		
				testRect = moveBlockRect(0, iIteration)
				if testRect.collidelist(rectNoCollideList) != -1:
					bestPos = (testRect.center[0], testRect.center[1] - 1)
					break
						
				
	#print time.time() - t
				
	return bestPos
	
#SLOW	
def checkPosClose(pos, checkPos, blockRect, rectNoCollideList, bestPos, bestDistSq):
	testRect = blockRect
	
	# Gets us starting from the closest corner - this should increase shortcutting
	if pos[0] <= checkPos[0]:
		iInc1 = 1
	else:
		iInc1 = -1
		
	if pos[1] <= checkPos[1]:
		iInc2 = 1
	else:
		iInc2 = -1	
		
	for i in range(iInc1 * -(blockRect.width / 2), iInc1 * ((blockRect.width / 2) + 1), iInc1):
		xSquared = (pos[0] - (checkPos[0] + i)) ** 2
		if xSquared < bestDistSq + (pos[1] - (checkPos[1] + (blockRect.height / 2))) ** 2:
			for j in range(iInc2 * -(blockRect.height / 2), iInc2 * ((blockRect.height / 2) + 1), iInc2):
				newPos = checkPos[0] + i, checkPos[1] + j
				distSq = xSquared + (pos[1] - newPos[1]) ** 2
				
				if distSq < bestDistSq:
					testRect.center = newPos
					
					if testRect.collidelist(rectNoCollideList) == -1:							
						bestDistSq = distSq
						bestPos = newPos				
	
	return bestPos, bestDistSq
	
def mag2D(vec):
	return math.sqrt(vec[0] ** 2 + vec[1] ** 2)
	
def dot2D(vec1, vec2):
	return vec1[0] * vec2[0] + vec1[1] * vec2[1]
	
def normalize2D(vec):
	factor = math.sqrt(vec[0] ** 2 + vec[1] ** 2)

	return vec[0] / factor, vec[1] / factor
	
def clamp(value, limits):
	if value < limits[0]:
		value = limits[0]
	if value > limits[1]:
		value = limits[1]
		
	return value	
	