# This is VERY messy... but was done VERY quickly, and works.

import pygame
import sys



from BkGlobals import *
import BkMain
import BtDifficultyMenu

from copy import deepcopy

from data import filepath

BORDER_X = 10
BORDER_Y = 10

def saveSettings():
	options = Options()


	f = file("settings.ini", "w")
	
	f.write("#Enable/disable full screen mode:\n")
	f.write("bFullScreen = ")
	
	if pygame.display.get_surface().get_flags() & 0xf0000000 >= 0x80000000:
		f.write("True")
	else:
		f.write("False")
		
	f.write(";\n\n")
	
	f.write("#Enable/disable mouse invertion:\n")
	f.write("bMouseInvert = ")	
	
	if options.isMouseInverted():
		f.write("True")
	else:
		f.write("False")		
	
	f.write(";\n\n")
	
	f.write("#Enable/disable sound:\n")
	f.write("bSound = ")	
	
	if options.isSound():
		f.write("True")
	else:
		f.write("False")	
		
	f.write(";\n\n")
	
	
	f.write("#Screen resolution:\n")
	f.write("Width = %i" %(pygame.display.get_surface().get_width()))
	f.write(";\n")
	f.write("Height = %i" %(pygame.display.get_surface().get_height()))
	
	f.write(";\n\n")
	
	difficulties = BtDifficultyMenu.DifficultyOptions().getDifficulties()
	
	f.write("#Difficulty options (0 = Easy, 1 = Normal, 2 = Hard:\n")
	f.write("Start Wind = %i" %(difficulties[0]))
	f.write(";\n")
	f.write("Start Time = %i" %(difficulties[1]))
	f.write(";\n")
	f.write("Win Time = %i" %(difficulties[2]))
	f.write(";\n")
	f.write("Win Height = %i" %(difficulties[3]))
	f.write(";\n")
	f.write("No. Blocks = %i" %(difficulties[4]))
	f.write(";\n\n")
	
class Options:
	__shared_state = {}
	def __init__(self):
		self.__dict__ = self.__shared_state
		
		try:
			self.bInit
		except:
			self.bInit = True
			self.mouseInverted = False
			self.sound = True
			
	def toggleInvertMouse(self):
		self.mouseInverted = not self.mouseInverted
		
	def isMouseInverted(self):
		return self.mouseInverted
		
	def toggleSound(self):
		self.sound = not self.sound
		
	def isSound(self):
		return self.sound	
			
class OptionsScreen:
	def __init__(self):
		pygame.mouse.set_visible(True)
		
		currentScreenSurf = pygame.display.get_surface().copy()
	
		bCurrentFullScreen = pygame.display.get_surface().get_flags() & 0xf0000000 >= 0x80000000
		currentRes = pygame.display.get_surface().get_width(), pygame.display.get_surface().get_height()
	
		self.bQuit = False
		self.options = [bCurrentFullScreen, currentRes]
		difficultyOptions = deepcopy(BtDifficultyMenu.DifficultyOptions().getDifficulties())
	
		bOpen = True
	
		updateRect = self.setupScreen()
		
	
		while bOpen:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit(0)
				elif event.type == pygame.KEYDOWN:
					if event.dict["key"] == pygame.K_ESCAPE:
						bOpen = False
					elif event.dict["key"] == pygame.K_F4:
						if pygame.key.get_mods() & pygame.KMOD_LALT or pygame.key.get_mods() & pygame.KMOD_RALT:
							sys.exit(0)		
				elif event.type == pygame.MOUSEMOTION:
					pos = event.dict["pos"]
					
					pygame.display.update(self.updateScreen(pos, False))
					break
				elif event.type == pygame.MOUSEBUTTONUP:
					if event.dict["button"] == 1:		
						pos = event.dict["pos"]

						pygame.display.update(self.updateScreen(pos, True))
						
						if self.bQuit:
							bOpen = False
						break
				elif event.type == EVENT_DIFFICULTYMENU:
					BtDifficultyMenu.DiffuciltyScreen(self.iFontSize)
					pygame.display.get_surface().blit(currentScreenSurf, (0, 0))
					self.updateScreen(pygame.mouse.get_pos(), False)
					pygame.display.flip()
						
		if self.options[0] != bCurrentFullScreen or self.options[1] != currentRes:
			saveSettings()
			BkMain.runGame(True, self.options[1][0], self.options[1][1], not self.options[0])
			
			
		if difficultyOptions != BtDifficultyMenu.DifficultyOptions().getDifficulties():
			saveSettings()
			BkMain.runGame(False)
			
						
									
					
	def setupScreen(self, iFontSize = 32):
		usedScreenResolutions = []
		self.availableScreenResolutions = []
		
		self.screenResSurfs = []
		self.highScreenResSurfs = []
		self.selectedScreenResSurfs = []
		
		font = pygame.font.Font(FONTPATH, iFontSize)
		
		for screenRes in pygame.display.list_modes():
			if screenRes not in self.availableScreenResolutions:
				self.availableScreenResolutions.append(screenRes)
				
		self.availableScreenResolutions.sort(reverse = True)
					
		iMaxWidth = 0
		iMaxHeight = 0
		iTotalHeight = 0
			
		for screenRes in self.availableScreenResolutions:
			self.screenResSurfs.append(font.render(str(screenRes[0]) + "x" + str(screenRes[1]), True, TEXT_NORMAL_COLOUR).convert_alpha())
			self.highScreenResSurfs.append(font.render(str(screenRes[0]) + "x" + str(screenRes[1]), True, TEXT_HIGHLIGHT_COLOUR).convert_alpha())
			self.selectedScreenResSurfs.append(font.render(str(screenRes[0]) + "x" + str(screenRes[1]), True, TEXT_DANGER_COLOUR).convert_alpha())
			
			width = self.screenResSurfs[-1].get_width()
			height = self.screenResSurfs[-1].get_height()
			iTotalHeight += height / 2.0
			
			if width > iMaxWidth:
				iMaxWidth = width
			if height > iMaxHeight:
				iMaxHeight = height
				
								
		iTotalHeight = int(iTotalHeight)
			
		self.fullScreenSurf = font.render("Full Screen", True, TEXT_NORMAL_COLOUR).convert_alpha()
		self.highFullScreenSurf = font.render("Full Screen", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		self.selectedFullScreenSurf = font.render("Full Screen", True, TEXT_DANGER_COLOUR).convert_alpha()

		self.windSurf = font.render("Windowed", True, TEXT_NORMAL_COLOUR).convert_alpha()
		self.highWindSurf = font.render("Windowed", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		self.selectedWindSurf = font.render("Windowed", True, TEXT_DANGER_COLOUR).convert_alpha()
		
		self.invMouseSurf = font.render("Invert Mouse", True, TEXT_NORMAL_COLOUR).convert_alpha()
		self.highInvMouseSurf = font.render("Invert Mouse", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		self.selectedInvMouseSurf = font.render("Invert Mouse", True, TEXT_DANGER_COLOUR).convert_alpha()		
		
		self.diffucltySurf = font.render("Difficulty Options", True, TEXT_NORMAL_COLOUR).convert_alpha()
		self.highDiffucltySurf = font.render("Difficulty Options", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()		
		
		self.exitSurf = font.render("Exit", True, TEXT_NORMAL_COLOUR).convert_alpha()
		self.highExitSurf = font.render("Exit", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		
		iTotalHeight += self.fullScreenSurf.get_height()
		iTotalHeight += self.windSurf.get_height()
		iTotalHeight += self.diffucltySurf.get_height()
		iTotalHeight += self.invMouseSurf.get_height()
		iTotalHeight += 2 * self.exitSurf.get_height()
		
		if self.fullScreenSurf.get_width() > iMaxWidth:
			iMaxWidth = self.fullScreenSurf.get_width() / 2
		if self.fullScreenSurf.get_height() > iMaxHeight:
			iMaxHeight = self.fullScreenSurf.get_height()
			
		# Not quite right, but running out of time , so it'll do
		if self.fullScreenSurf.get_width() > iMaxWidth:
			iMaxWidth = self.fullScreenSurf.get_width()
		if self.fullScreenSurf.get_height() > iMaxHeight:
			iMaxHeight = self.fullScreenSurf.get_height()	
		if self.windSurf.get_width() > iMaxWidth:
			iMaxWidth = self.windSurf.get_width()
		if self.windSurf.get_height() > iMaxHeight:
			iMaxHeight = self.windSurf.get_height()
		if self.exitSurf.get_width() > iMaxWidth:
			iMaxWidth = self.exitSurf.get_width()
		if self.diffucltySurf.get_height() > iMaxHeight:
			iMaxHeight = self.diffucltySurf.get_height()				
		if self.exitSurf.get_height() > iMaxHeight:
			iMaxHeight = self.exitSurf.get_height()	

			
		self.iMaxHeight = iMaxHeight
		self.iMaxWidth = iMaxWidth
		self.iTotalHeight = iTotalHeight


		if 2 * iMaxWidth + 5 * BORDER_X > pygame.display.get_surface().get_width() or iTotalHeight + 4 * BORDER_Y > pygame.display.get_surface().get_height():
			return self.setupScreen(iFontSize - 1)
			
		self.mainSurf = pygame.Surface((2 * iMaxWidth + 5 * BORDER_X, iTotalHeight + 4 * BORDER_Y)).convert()
		self.mainSurf.fill(NEXT_BLOCK_BG_COLOUR)
		self.mainSurf.fill(OPTIONS_BG_COLOUR, (BORDER_X, BORDER_Y, 2 * iMaxWidth + 3 * BORDER_X, iTotalHeight + 2 * BORDER_Y))
		self.pos = (pygame.display.get_surface().get_width() - self.mainSurf.get_width()) / 2, (pygame.display.get_surface().get_height() - self.mainSurf.get_height()) / 2
		
		self.iFontSize = iFontSize
		
		return pygame.display.get_surface().blit(self.mainSurf, self.pos)
		
		
	def updateScreen(self, pos, bClick):
		self.mainSurf.fill(NEXT_BLOCK_BG_COLOUR)
		self.mainSurf.fill(OPTIONS_BG_COLOUR, (BORDER_X, BORDER_Y, 2 * self.iMaxWidth + 3 * BORDER_X, self.iTotalHeight + 2 * BORDER_Y))
	
		options = Options()
	
		i = 0
		for screenResSurf in self.screenResSurfs:
		
			screenRes = self.availableScreenResolutions[i]
			
			if screenRes == self.options[1]:
				screenResSurf = self.selectedScreenResSurfs[i]
		
			if not i % 2:
				if screenResSurf == self.screenResSurfs[-1]:
					blitPos = ((2 * self.iMaxWidth + 5 * BORDER_X - screenResSurf.get_width()) / 2, BORDER_Y + (self.iMaxHeight * (i / 2)))
					if screenResSurf.get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
						screenResSurf = self.highScreenResSurfs[i]
						if bClick:
							self.options[1] = screenRes
							
							

					self.mainSurf.blit(screenResSurf, blitPos)	
				else:
					blitPos = (2 * BORDER_X + ((self.iMaxWidth - screenResSurf.get_width()) / 2), BORDER_Y + (self.iMaxHeight * (i / 2)))				
					if screenResSurf.get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
						screenResSurf = self.highScreenResSurfs[i]				
						if bClick:
							self.options[1] = screenRes
							
					self.mainSurf.blit(screenResSurf, blitPos)
			else:
				blitPos = (3 * BORDER_X + self.iMaxWidth + ((self.iMaxWidth - screenResSurf.get_width()) / 2), BORDER_Y + (self.iMaxHeight * (i / 2)))
				if screenResSurf.get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
					screenResSurf = self.highScreenResSurfs[i]				
					if bClick:
						self.options[1] = screenRes
					
				self.mainSurf.blit(screenResSurf, blitPos)
			
			i += 1
			
		blitPos1 = ((2 * self.iMaxWidth + 5 * BORDER_X - self.fullScreenSurf.get_width()) / 2, BORDER_Y + (self.iMaxHeight * ((i + 1) / 2)))
		blitPos2 = ((2 * self.iMaxWidth + 5 * BORDER_X - self.windSurf.get_width()) / 2, BORDER_Y + (self.iMaxHeight * ((i + 3) / 2)))
		if self.options[0]:
			if self.fullScreenSurf.get_rect(left = blitPos1[0] + self.pos[0], top = blitPos1[1] + self.pos[1]).collidepoint(pos):
				if bClick:
					self.options[0] = True				
				self.mainSurf.blit(self.highFullScreenSurf, blitPos1)
			else:
				self.mainSurf.blit(self.selectedFullScreenSurf, blitPos1)
			if self.windSurf.get_rect(left = blitPos2[0] + self.pos[0], top = blitPos2[1] + self.pos[1]).collidepoint(pos):
				if bClick:
					self.options[0] = False			
				self.mainSurf.blit(self.highWindSurf, blitPos2)
			else:				
				self.mainSurf.blit(self.windSurf, blitPos2)
		else:
			if self.fullScreenSurf.get_rect(left = blitPos1[0] + self.pos[0], top = blitPos1[1] + self.pos[1]).collidepoint(pos):
				if bClick:
					self.options[0] = True				
				self.mainSurf.blit(self.highFullScreenSurf, blitPos1)
			else:
				self.mainSurf.blit(self.fullScreenSurf, blitPos1)
			if self.windSurf.get_rect(left = blitPos2[0] + self.pos[0], top = blitPos2[1] + self.pos[1]).collidepoint(pos):
				if bClick:
					self.options[0] = False			
				self.mainSurf.blit(self.highWindSurf, blitPos2)
			else:				
				self.mainSurf.blit(self.selectedWindSurf, blitPos2)
				
				
		blitPos = ((2 * self.iMaxWidth + 5 * BORDER_X - self.invMouseSurf.get_width()) / 2, BORDER_Y + (self.iMaxHeight * ((i + 5) / 2)))
		
		if self.invMouseSurf.get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
			self.mainSurf.blit(self.highInvMouseSurf, blitPos)
			if bClick:
				options.toggleInvertMouse()
		else:
			if options.isMouseInverted():
				self.mainSurf.blit(self.selectedInvMouseSurf, blitPos)
			else:
				self.mainSurf.blit(self.invMouseSurf, blitPos)						
			
				
		blitPos = ((2 * self.iMaxWidth + 5 * BORDER_X - self.diffucltySurf.get_width()) / 2, BORDER_Y + (self.iMaxHeight * ((i + 9) / 2)))
		
		if self.diffucltySurf.get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
			self.mainSurf.blit(self.highDiffucltySurf, blitPos)
			if bClick:
				pygame.event.post(pygame.event.Event(EVENT_DIFFICULTYMENU, {}))
		else:
			self.mainSurf.blit(self.diffucltySurf, blitPos)		
		
		blitPos = ((2 * self.iMaxWidth + 5 * BORDER_X - self.exitSurf.get_width()) / 2, BORDER_Y + (self.iMaxHeight * ((i + 11) / 2)))
				
		if self.exitSurf.get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
			self.mainSurf.blit(self.highExitSurf, blitPos)
			if bClick:
				self.bQuit = True
		else:
			self.mainSurf.blit(self.exitSurf, blitPos)
			
			
		
		return pygame.display.get_surface().blit(self.mainSurf, self.pos)
			
			
			
			
			
			
			
			